import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;


public class Test2 {
    
    public static void main(String[] args) throws ZipException, IOException {
        
        String jar = args[0];
        String loopString = args[1];
        int loop = Integer.parseInt(loopString);
        String closeStream = args[2];
        
        ZipEntry entry = getFirstFileZipEntry(new File(jar));
        for (int i = 0; i < loop; i++) {
            ZipFile zf = new ZipFile(jar);
            InputStream stream = null;
            try {
                stream = zf.getInputStream(entry);
                int value = 0;
                while ((value = stream.read()) >= 0) {
                    //do nothing
                }
            } catch (Exception e) {
                System.out.println("Error " + entry.getName());
            } finally {
                if (stream != null && "true".equalsIgnoreCase(closeStream)) {
                    stream.close();
                }
                zf.close();
            }
        }
    }
    
    private static ZipEntry getFirstFileZipEntry(File jar) throws ZipException, IOException {
        ZipFile zf = new ZipFile(jar);
        Enumeration<? extends ZipEntry> entries = zf.entries();
        while(entries.hasMoreElements()) {
            ZipEntry entry = entries.nextElement();
            if (!entry.isDirectory()) return entry;
        }
        return null;
    }

}
